<?php

/**
 * webEdition CMS
 *
 * $Rev: 8665 $
 * $Author: mokraemer $
 * $Date: 2014-12-02 17:11:48 +0100 (Tue, 02 Dec 2014) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
function we_parse_tag_repeatShopItem($a, $content, $attribs){
	if(($foo = attributFehltError($attribs, 'shopname', __FUNCTION__))){
		return $foo;
	}

	$attribs['_type'] = 'start';
	return '<?php ' . we_tag_tagParser::printTag('repeatShopItem', $attribs) . '; while($GLOBALS[\'lv\']->next_record()) {?>' . $content . '<?php } ' . we_tag_tagParser::printTag('repeatShopItem', array('_type' => 'stop')) . ';?>';
}

function we_tag_repeatShopItem($attribs){
	if(!defined('SHOP_TABLE')){
		echo modulFehltError('Shop', __FUNCTION__);
		return;
	}
	$shopname = weTag_getAttribute("shopname", $attribs, '', we_base_request::STRING);

	//internal Attribute
	$_type = weTag_getAttribute('_type', $attribs, '', we_base_request::STRING);
	switch($_type){
		case 'start':
			if(($foo = attributFehltError($attribs, "shopname", __FUNCTION__))){
				echo $foo;
				return;
			}
			we_base_moduleInfo::isActive('shop');

			$_SESSION["we_shopname"] = $shopname;

			if(!isset($GLOBALS[$shopname]) || empty($GLOBALS[$shopname])){
				echo parseError(sprintf(g_l('parser', '[missing_createShop]'), 'repeatShopItem'));
			}
			$GLOBALS["lv"] = new we_shop_shop($GLOBALS[$shopname]);
			break;
		case 'stop':
			if(isset($GLOBALS['we_lv_array'])){
				we_post_tag_listview();
			} else {
				unset($GLOBALS["lv"]);
			}
			break;
	}
}
