<?php

/**
 * webEdition CMS
 *
 * $Rev: 7705 $
 * $Author: mokraemer $
 * $Date: 2014-06-10 21:46:56 +0200 (Tue, 10 Jun 2014) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
$html = array(
	'a' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup', 'onblur', 'onfocus',),
		'norm' => array('accesskey', 'charset', 'coords', 'href', 'hreflang', 'name', 'rel', 'rev', 'shape', 'tabindex', 'target', 'type'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'abbr' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'acronym' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'address' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('contenteditable', 'contextmenu', 'dir', 'draggable', 'irrelevant', 'ref', 'tabindex'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'applet' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title'),
		'js' => array('onload'),
		'norm' => array('align', 'alt', 'archive', 'code', 'codebase', 'height', 'hspace', 'name', 'object', 'vspace', 'width'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'area' => array(
		'default' => array('id', 'title'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup', 'onblur', 'onfocus'),
		'norm' => array('accesskey', 'alt', 'coords', 'href', 'nohref', 'shape', 'tabindex', 'target'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'b' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'base' => array(
		'default' => array(),
		'js' => array(),
		'norm' => array('href', 'target'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'basefont' => array(
		'default' => array('id'),
		'js' => array(),
		'norm' => array('color', 'face', 'size'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'bdo' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir'),
		'js' => array(),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'big' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'blockquote' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('cite'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'body' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup', 'onload', 'onunload'),
		'norm' => array('alink', 'background', 'bgcolor', 'link', 'text', 'vlink'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'br' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title',),
		'js' => array(),
		'norm' => array('clear'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'button' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup', 'onblur', 'onfocus'),
		'norm' => array('accesskey', 'disabled="disabled"', 'name', 'tabindex', 'type', 'value'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'caption' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('align'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'center' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'cite' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'code' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'col' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('align', 'char', 'charoff', 'span', 'valign', 'width'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'colgroup' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('align', 'char', 'charoff', 'span', 'valign', 'width'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'dd' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'del' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('cite', 'datetime'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'dfn' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'dir' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('compact'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'div' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('align'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'dl' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('compact'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'dt' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'em' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'fieldset' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'font' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array(),
		'norm' => array('color', 'face', 'size'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'form' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup', 'onreset', 'onsubmit'),
		'norm' => array('action', 'accept', 'accept-charset', 'enctype', 'method', 'name', 'target'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'frame' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title',),
		'js' => array(),
		'norm' => array('frameborder', 'longdesc', 'marginheight', 'marginwidth', 'name', 'noresize', 'scrolling', 'src'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'frameset' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onload', 'onunload'),
		'norm' => array('cols', 'rows'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'h1' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('align'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'h2' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('align'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'h3' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('align'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'h4' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('align'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'h5' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('align'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'h6' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('align'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'head' => array(
		'default' => array('dir', 'lang'),
		'js' => array(),
		'norm' => array('profile'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'hr' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('align', 'noshade', 'size', 'width'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'html' => array(
		'default' => array('dir', 'lang'),
		'js' => array(),
		'norm' => array('version'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'i' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'iframe' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title'),
		'js' => array(),
		'norm' => array('align', 'frameborder', 'height', 'longdesc', 'marginheight', 'marginwidth', 'name', 'scrolling', 'src', 'width'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'img' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup', 'onerror', 'onload'),
		'norm' => array('align', 'alt', 'border', 'height', 'hspace', 'ismap', 'longdesc', 'name', 'src', 'usemap', 'vspace', 'width'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'input' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup', 'onchange', 'onblur', 'onfocus', 'onselect'),
		'norm' => array('accept', 'accesskey', 'align', 'alt', 'checked="checked"', 'disabled="disabled"', 'ismap', 'maxlength', 'name', 'readonly', 'size', 'src', 'tabindex', 'type', 'usemap', 'value', 'type="button"', 'type="hidden"', 'type="file"', 'type="submit"', 'type="checkbox"', 'type="password"', 'type="radio"', 'type="reset"',),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array('type = "color"', 'type = "date"', 'type = "datetime"', 'type = "datetime-local"', 'type = "email"', 'type = "image"', 'type = "month"', 'type = "number"', 'type = "range"', 'type = "search"', 'type = "tel"', 'type = "text"', 'type = "time"', 'type = "url"', 'type = "week"'),
	),
	'ins' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('cite', 'datetime'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'kbd' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'label' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup', 'onblur', 'onfocus'),
		'norm' => array('accesskey', 'for'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'legend' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('accesskey', 'align'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'li' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('type', 'value'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'link' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('charset', 'href', 'hreflang', 'media', 'rel', 'rev', 'target', 'type'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'map' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('name'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'menu' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('compact'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'meta' => array(
		'default' => array('dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('content', 'http-equiv', 'name', 'scheme'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'noframes' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'noscript' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'object' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('align', 'archive', 'border', 'classid', 'codebase', 'codetype', 'data', 'declare', 'height', 'hspace', 'name', 'standby', 'tabindex', 'type', 'usemap', 'vspace', 'width'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'ol' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('compact', 'start', 'type'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'optgroup' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('disabled="disabled"', 'label'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'option' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('disabled="disabled"', 'label', 'selected="selected"', 'value'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'p' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('align'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'param' => array(
		'default' => array('id'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('name', 'type', 'value', 'valuetype'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'pre' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('width'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'q' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('cite'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	's' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'samp' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'script' => array(
		'default' => array(),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('charset', 'defer', 'event', 'language', 'for', 'src', 'type'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'select' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup', 'onblur', 'onchange', 'onfocus'),
		'norm' => array('disabled="disabled"', 'multiple', 'name', 'size', 'tabindex'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'small' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'span' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'strike' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'strong' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'style' => array(
		'default' => array('title', 'dir', 'lang'),
		'js' => array(),
		'norm' => array('media', 'type'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'sub' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'sup' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'table' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('align', 'background', 'bgcolor', 'border', 'cellpadding', 'cellspacing', 'frame', 'rules', 'summary', 'width'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'tbody' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('align', 'char', 'charoff', 'valign'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'td' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('abbr', 'align', 'axis', 'background', 'bgcolor', 'char', 'charoff', 'colspan', 'headers', 'height', 'nowrap', 'rowspan', 'scope', 'valign', 'width'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'textarea' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup', 'onblur', 'onchange', 'onfocus', 'onselect'),
		'norm' => array('accesskey', 'cols', 'disabled="disabled"', 'name', 'readonly', 'rows', 'tabindex'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'tfoot' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('align', 'char', 'charoff', 'valign'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'th' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('align', 'axis', 'background', 'bgcolor', 'char', 'charoff', 'colspan', 'headers', 'height', 'nowrap', 'rowspan', 'scope', 'valign', 'width'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'thead' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('align', 'char', 'charoff', 'valign'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'title' => array(
		'default' => array('dir', 'lang'),
		'js' => array(),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'tr' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('align', 'background', 'bgcolor', 'char', 'charoff', 'valign'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'tt' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'u' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'ul' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array('compact', 'type'),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'var' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'!DOCTYPE' => array(
	),
	'?php' => array(
	),
);


$html5 = array(
	'article' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'aside' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'bdi' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'command' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'details' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'summary' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'figure' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'figcaption' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'footer' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'header' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'hgroup' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'mark' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'meter' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'nav' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'progress' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'ruby' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'rt' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'rp' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'section' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'time' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'wbr' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'audio' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'video' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'source' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'embed' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'track' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'canvas' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'datalist' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'keygen' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
	'output' => array(
		'default' => array('class', 'accesskey', 'tabindex', 'id', 'style', 'title', 'dir', 'lang'),
		'js' => array('onclick', 'ondblclick', 'onmousedown', 'onmouseup', 'onmouseover', 'onmousemove', 'onmouseout', 'onkeypress', 'onkeydown', 'onkeyup'),
		'norm' => array(),
		'default_html5' => array('contenteditable', 'contextmenu', 'draggable', 'dropzone', 'hidden', 'spellcheck'),
		'html5' => array(),
	),
);
